<template>
  <GI18nCard
    :i18n="`${i18nBase}.title`"
    :card="card"
    no-padding
    :level="level"
    :optional="optional"
    :wiki-entry="wikiEntry"
    @deleteElement="$emit('deleteElement')"
  >
    <template #card-title-append>
      <v-spacer />
      <GTextField
        v-if="enableSearch"
        v-model="search"
        clearable
        flat
        outlined
        hide-details
        prepend-inner-icon="search"
        i18n="form.search"
      />
      <slot name="card-title-append" />
      <GIconBtn
        v-if="!disableCreate"
        :i18n="i18nBase + `.add`"
        small-btn
        icon="add"
        :btn-class="level === 'third' ? 'theme--light' : 'theme--dark'"
        @click="create"
      />
    </template>
    <GAddEditDialog
      ref="addEditDialog"
      v-slot="{ item, updateAvailableElements }"
      :i18n-base="i18nBase"
      :use-wrapper="useWrapper"
    >
      <slot
        name="form"
        :item="item"
        :update-available-elements="updateAvailableElements"
        :index="editedIndex"
      />
    </GAddEditDialog>
    <v-data-table
      calculate-widths
      :loading="loading"
      :headers="internalHeaders"
      :hide-default-header="hideDefaultHeader"
      :items="items"
      :search="search"
      hide-default-footer
      disable-pagination
    >
      <template v-for="(_, name) in itemSlots" #[`item.${name}`]="data">
        <slot :name="`item.${name}`" v-bind="data" />
      </template>

      <template #[`item.actions`]="{ item }">
        <v-icon
          v-if="!disableEdit"
          :aria-label="$t('form.edit')"
          small
          class="mr-2"
          @click="edit(item)"
        >
          edit
        </v-icon>
        <v-icon
          v-if="allowRemove || hasRemoveListener"
          :aria-label="$t('form.edit')"
          small
          @click="remove(item)"
        >
          delete
        </v-icon>
      </template>
      <template #no-data>
        <!-- background color definition in app.scss: .v-data-table__empty-wrapper -->
        <v-alert color="transparent" icon="warning" class="ma-0 pa-0">
          {{ $t(`${i18nBase}.empty`) }}
        </v-alert>
      </template>
    </v-data-table>
  </GI18nCard>
</template>

<script>
import { getPrefixedScopedSlots } from "vuetify/es5/util/helpers";
import GAddEditDialog from "./GAddEditDialog";
import { cloneWithPrototype, isFunction } from "~/assets/util/general";
import GI18nCard from "~/components/App/Common/GI18nCard";
import GTextField from "~/components/App/Form/gTextField";
import GIconBtn from "~/components/App/Common/GIconBtn.vue";

export default {
  name: "GManageTable",
  components: { GIconBtn, GTextField, GI18nCard, GAddEditDialog },
  props: {
    i18nBase: String,
    card: Boolean,
    level: String,
    enableSearch: Boolean,
    optional: Boolean,
    wikiEntry: String,
    headers: {
      type: Array,
    },
    loading: {
      type: Boolean,
    },
    useWrapper: {
      type: Boolean,
    },
    items: {
      type: Array,
    },
    getFullItem: {
      type: Function,
    },
    getNewItem: {
      type: Function,
    },
    allowRemove: {
      type: Boolean,
    },
    disableEdit: {
      type: Boolean,
    },
    disableCreate: {
      type: Boolean,
    },
    hideDefaultHeader: {
      type: Boolean,
      default: false,
    },
  },
  data() {
    return {
      search: "",
      showDialog: false,
      editedIndex: -1,
      editedItem: null,
    };
  },
  computed: {
    internalHeaders() {
      return [
        ...this.headers,
        ...(this.allowRemove || !this.disableEdit
          ? [
              {
                text: this.$t("form.actions"),
                value: "actions",
                align: "end",
                sortable: false,
              },
            ]
          : []),
      ];
    },
    itemSlots() {
      return getPrefixedScopedSlots("item.", this.$scopedSlots);
    },
    hasRemoveListener() {
      return this.$listeners && this.$listeners.remove;
    },
  },
  methods: {
    async create() {
      let item = {};
      if (isFunction(this.getNewItem)) {
        item = await this.getNewItem();
      }
      const createdItem = await this.$refs.addEditDialog.create(item);
      this.$emit("create", createdItem);
    },
    async edit(item) {
      let clonedItem = cloneWithPrototype(item);

      if (isFunction(this.getFullItem)) {
        clonedItem = await this.getFullItem(clonedItem);
      }

      const editedItem = await this.$refs.addEditDialog.edit(clonedItem);
      this.$emit("edit", editedItem, this.items.indexOf(item));
    },
    remove(item) {
      confirm(this.$t(`${this.i18nBase}.confirmRemove`)) &&
        this.$emit("remove", item);
    },
  },
};
</script>
